# Algorithmique et structures de données 2020-21

Contenu du cours 6 du 28.10.2020

*****

##  Récursivité

-   Exemple de la factorielle : n ! = n·(n-1)·(n-2)·... ·3·2·1 = n·(n-1) !   
    Donc fact(n) = n·fact(n-1) (récursivité)  
    et fact(1) = 1 (condition d'arrêt)
```C
        int fact(int n) {
            if (n > 1) {
                return n*fact(n­1);
            } else {
                return 1;
            }
        }
        void main() {
            int f = fact(4);
        }
```

![Illustration](./figures/fig_recursivite_factorielle.png)

-   Exemple du PGCD   
    Algorithme d'Euclide pour le PGCD de 42 et 27  

>       42 = 27·1 + 15  
>       27 = 15·1 + 12  
>       15 = 12·1 +  3  
>       12 =  3·4 +  0  
    PGCD(42,27)=PGCD(27,15)=PGCD(15,12)=PGCD(12,3)=3
```C
        int pgcd(int n,int m) {
            if (n%m > 0) {
                return pgcd(m,n%m);
            } else {
                return m;
            }
        }
```

![Illustration de la récursivité pour l'algorithme d'Euclide](./figures/fig_recursivite_pgcd_euclide.png)

-   Exemple de l'écriture binaire
```C
        void binaire(int n) {
            printf("%d",n%2);
            if (n/2 != 0) {
                binaire(n/2);
            } else {
                printf("\n");
            }
            // printf("%d",n%2);
        }

        Binaire(13); // affiche 1 0 1 1 puis un retour à la ligne`
```
> > > $\hspace*{36mm} 2^0 2^1 2^2 2^3$  

![Illustration de la récursivité pour l'écriture binaire](./figures/fig_recursivite_binaire.png)

-   Que se passe-t-il si on décommente le deuxième `printf` ?

##  Exemples et exercices de récursivité

-   Algorithme du PPCM de deux nombres `n` et `m`
    -   `ppcm(mult_n,mult_m) = ppcm(mult_n + n, mult_m)`    
        si `mult_n < mult_m`   (récursivité)
    -   `ppcm(mult_n,mult_m) = ppcm(mult_n, mult_m + m)`    
        si `mult_n > mult_m`   (récursivité)
    -   `ppcm(mult_n,mult_m) = mult_n`      
        si `mult_n = mult_m`   (condition d’arrêt)

-   Puissance indienne
\begin{align*}
a^b & = a^{b/2}\cdot a^{b/2} & \textrm{ si $b$ est pair (récursivité)} \\
a^b & = a^{b-1}\cdot a  & \textrm{ si $b$ est impair (récursivité)} \\
a^0 & = 1   & \textrm{ (condition d’arrêt)}
\end{align*}

-   Suite de Fibonacci
\begin{align*}
a_n & = a_{n-1} + a_{n-2} & \textrm{  (récursivité)} \\
a_1 & = 1, a_0 = 0 & \textrm{  (condition d’arrêt)}
\end{align*}

##  Problème des 8-reines

- Le but du problème des 8 reines est de placer 8 reines d'un jeu d'échecs sur un échiquier de $8 \times 8$ cases sans que les reines ne puissent se menacer mutuellement, conformément aux règles du jeu d'échecs. 
- Ainsi, deux reines ne devraient jamais partager la même rangée, colonne, ou diagonale.
- Le problème se généralise au placement de N reines sur un échiquier de $N \times N$ cases. Pour $N=8$, il y a 92 solutions
- Il s'agit d'un exemple classique de problème de backtracking qui se programme avec la récursivité.

![Problème des 8-reines. Source : wikipedia, https://fr.wikipedia.org/wiki/Problème_des_huit_dames](./figures/fig_recursivite_8_reines.png)